# I.2) Ligne de commande complte pour le test des deux autres machines: 

for machine in oursin corail; do
    if ping -t 1 $machine >&- 2>&-; then
	echo "$machine repond a ICMP"
	else echo "$machine ne repond pas a ICMP"
    fi
done

# Nota: on peut aussi remplacer >&- et 2>&- par > /dev/null 2>&1 
#
# Test de toutes les machines dans la salle (de 1  13):

i=1
while test $i -le 13; do
    machine=192.168.0.$i
    if ping -t 1 $machine >&- 2>&-; then
	echo "$machine repond a ICMP"
	else echo "$machine ne repond pas a ICMP"
    fi
    i=$((i+1))
done


# I.3) Cration de comptes sur oursin et corail:
#

for machine in oursin corail; do
    ssh root@$machine "echo Creation de compte sur $machine. ; adduser dumartin && passwd dumartin"
done


# I.4) Recopie automatise vers oursin et corail
#
# Note: il faut d'abord crer .ssh dans le rpertoire par dfaut sur
# la machine distante, faute de quoi scp chouera
#

for machine in oursin corail; do
    ssh dumartin@$machine "test -d ~/.ssh || mkdir ~/.ssh"
    scp ~/.ssh/id_rsa.pub dumartin@${machine}:\~/.ssh/authorized_keys
done


# Partie II
#
# II.1) rwho sur les trois machines
#
for machine in oursin meduse corail; do
    echo "${machine}:"
    ssh dumartin@$machine who | sed "s/^/\t/"
done


# II.2) 
#

function quiestsur () {
    while test "$1"; do
	echo "${1}:"
	ssh dumartin@$1 who | sed "s/^/\t/"
	shift
    done
}


# II.3)
#

function quiestsur () {
    while test "$1"; do
	echo "${1}:"
	if ping -t 1 $1 >&- 2>&-; then
	    ssh dumartin@$1 who | sed "s/^/\t/"
	else
	    echo '??'
	fi
	shift
    done
}


# II.4) rwho sur les machines de /etc/hosts
#
# L'ide est de couper le premier champs de /etc/hosts et d'appliquer une
# substitution de commande pour savoir sur quelles machines on doit boucler.
# ATTENTION: la manipulation est hautement dpendante de la manire dont 
# /etc/hosts est format
#

quiestsur `cut -f1 /etc/hosts`


# II.5) Utilisation de getopt
#
# Note : il y a plusieurs manires d'exploiter la sortie de getopt. 
# La manire la plus simple consiste  rassigner les arguments  cette
# sortie, c'est ce que fait la ligne set -- $arguments ci-dessous.
#
function quiestsur () {
    local liste=""  # liste de machines a tester

    arguments=`getopt af: $*`
    if test $? -eq 0; then   # sinon, mauvaise option
	set -- $arguments
	while test "$1"; do
	    case $1 in
		-a) liste=`cut -f1 /etc/hosts`; shift ;;
		-f) liste=`cut -f1 $2`; shift; shift ;;
		--) shift;; # rien d'autre a faire: les noms de machines suivent	    
		*) liste="${liste} $1" ; shift ;;
	    esac
	done	
	for machine in $liste; do
	    if ping -t 1 $machine >&- 2>&-; then
		ssh dumartin@$machine who | sed "s/^/\t/"
	    else
		echo '??'
	    fi
	done
    else
	return 1
    fi
}

 
